%This function integrates fixations over time
function [Current_Prob, Class_Prob] = NIMBLE_Classify(Net, patch_collection, location_collection, Class_Prob, Prior)

Use_Prior = true;


scores = NN_KDE_Classify(patch_collection, location_collection, Net); %classify fixation

tiny = 0.000001;
scores = double(scores);
scores(scores < tiny) = tiny;
patch_prob = bsxfun(@rdivide, scores,  sum(scores, 2));
    
if isempty(Class_Prob)
    Class_Prob = 0;
end


if Use_Prior && isempty(Prior) %we assume a uniform prior
    Prior = ones(1, size(patch_prob, 2)) ./ size(patch_prob, 2);
elseif ~Use_Prior
    Prior = 1;
end

%product rule
Class_Prob = Class_Prob + cumsum(log(patch_prob), 1);
Class_Prob(~isfinite(Class_Prob)) = 0;
Current_Prob = exp(bsxfun(@plus, bsxfun(@minus, double(Class_Prob),  double(max(Class_Prob, [], 2))),  log(Prior))) + .00001;

Current_Prob = bsxfun(@rdivide, Current_Prob, sum(Current_Prob, 2));
